JsonCpp project page | Classes | Namespace | JsonCpp home page

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Friends | List of all members
Json::Value Class Reference

Represents a JSON value. More...

`#include <json/value.h>`

Collaboration diagram for Json::Value:

## Public Types
using | Members = std::vector<String>
using | iterator = ValueIterator
using | const_iterator = ValueConstIterator
using | UInt = Json::UInt
using | Int = Json::Int
using | UInt64 = Json::UInt64
using | Int64 = Json::Int64
using | LargestInt = Json::LargestInt
using | LargestUInt = Json::LargestUInt
using | ArrayIndex = Json::ArrayIndex
using | value_type = std::string

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type.
| Value (Int value)
| Value (UInt value)
| Value (Int64 value)
| Value (UInt64 value)
| Value (double value)
| Value (const char *value)
| Copy til first 0. (NULL causes to seg-fault.).
| Value (const char *begin, const char *end)
| Copy all, incl zeroes.
| Value (const StaticString &value)
| Constructs a value from a static string.
| Value (const String &value)
| Value (bool value)
| Value (std::nullptr_t ptr)=delete
| Value (const Value &other)
| Value (Value &&other) noexcept
| ~Value ()
Value & | operator= (const Value &other)
Value & | operator= (Value &&other) noexcept
void | swap (Value &other)
| Swap everything.
void | swapPayload (Value &other)
| Swap values but leave comments and source offsets in place.
void | copy (const Value &other)
| copy everything.
void | copyPayload (const Value &other)
| copy values but leave comments and source offsets in place.
ValueType | type () const
bool | operator< (const Value &other) const
| Compare payload only, not comments etc.
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other) const
const char * | asCString () const
| Embedded zeroes could cause you trouble!
String | asString () const
| Embedded zeroes are possible.
bool | getString (char const **begin, char const **end) const
| Get raw char* of string-value.
Int | asInt () const
UInt | asUInt () const
Int64 | asInt64 () const
UInt64 | asUInt64 () const
LargestInt | asLargestInt () const
LargestUInt | asLargestUInt () const
float | asFloat () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isInt64 () const
bool | isUInt () const
bool | isUInt64 () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
template<typename T>
T | as () const =delete
| The as<T> and is<T> member function templates and specializations.
template<typename T>
bool | is () const =delete
bool | isConvertibleTo (ValueType other) const
ArrayIndex | size () const
| Number of values in array or object.
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false.
| operator bool () const
| Return !isNull().
void | clear ()
| Remove all object members and array elements.
void | resize (ArrayIndex newSize)
| Resize the array to newSize elements.
Value | get (ArrayIndex index, const Value &defaultValue) const
| If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.
bool | isValidIndex (ArrayIndex index) const
| Return true if index < size().
Value & | append (const Value &value)
| Append value to array at the end.
Value & | append (Value &&value)
bool | insert (ArrayIndex index, const Value &newValue)
| Insert value in array at specific index.
bool | insert (ArrayIndex index, Value &&newValue)
Value & | operator[] (const char *key)
| Access an object value by name, create a null member if it does not exist.
const Value & | operator[] (const char *key) const
| Access an object value by name, returns null if there is no member with that name.
Value & | operator[] (const String &key)
| Access an object value by name, create a null member if it does not exist.
const Value & | operator[] (const String &key) const
| Access an object value by name, returns null if there is no member with that name.
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist.
Value | get (const char *key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value | get (const String &key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value | get (const char *begin, const char *end, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise.
Value const * | find (char const *begin, char const *end) const
| Most general and efficient version of isMember()const, get()const, and operator[]const.
Value const * | find (const String &key) const
| Most general and efficient version of isMember()const, get()const, and operator[]const.
template<typename T, bool(T::*)() const TMemFn>
Value const * | findValue (const String &key) const
| Calls find and only returns a valid pointer if the type is found.
Value const * | findNull (const String &key) const
Value const * | findBool (const String &key) const
Value const * | findInt (const String &key) const
Value const * | findInt64 (const String &key) const
Value const * | findUInt (const String &key) const
Value const * | findUInt64 (const String &key) const
Value const * | findIntegral (const String &key) const
Value const * | findDouble (const String &key) const
Value const * | findNumeric (const String &key) const
Value const * | findString (const String &key) const
Value const * | findArray (const String &key) const
Value const * | findObject (const String &key) const
Value * | demand (char const *begin, char const *end)
| Most general and efficient version of object-mutators.
void | removeMember (const char *key)
| Remove and return the named member.
void | removeMember (const String &key)
| Same as removeMember(const char*).
bool | removeMember (String const &key, Value *removed)
| Remove the named map member.
bool | removeMember (const char *key, Value *removed)
| Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.
bool | removeMember (const char *begin, const char *end, Value *removed)
| Same as removeMember(String const& key, Value* removed).
bool | removeIndex (ArrayIndex index, Value *removed)
| Remove the indexed array element.
bool | isMember (const char *key) const
| Return true if the object has a member named key.
bool | isMember (const String &key) const
| Return true if the object has a member named key.
bool | isMember (const char *begin, const char *end) const
| Same as isMember(String const& key)const.
Members | getMemberNames () const
| Return a list of the member names.
| __declspec (deprecated("Use setComment(String const&) instead.")) void setComment(const char *comment
void | setComment (const char *comment, size_t len, CommentPlacement placement)
| Comments must be //... or /* ... *‍/.
void | setComment (String comment, CommentPlacement placement)
| Comments must be //... or /* ... *‍/.
bool | hasComment (CommentPlacement placement) const
String | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines.
String | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()
ValueMembersView | members ()
ValueConstMembersView | members () const
const Value & | front () const
| Returns a reference to the first element in the Value.
Value & | front ()
| Returns a reference to the first element in the Value.
const Value & | back () const
| Returns a reference to the last element in the Value.
Value & | back ()
| Returns a reference to the last element in the Value.
void | setOffsetStart (ptrdiff_t start)
void | setOffsetLimit (ptrdiff_t limit)
ptrdiff_t | getOffsetStart () const
ptrdiff_t | getOffsetLimit () const
template<>
bool | as () const
template<>
bool | is () const
template<>
Int | as () const
template<>
bool | is () const
template<>
UInt | as () const
template<>
bool | is () const
template<>
Int64 | as () const
template<>
bool | is () const
template<>
UInt64 | as () const
template<>
bool | is () const
template<>
double | as () const
template<>
bool | is () const
template<>
String | as () const
template<>
bool | is () const
template<>
float | as () const
| These as specializations are type conversions, and do not have a corresponding is.
template<>
const char * | as () const
Value & | operator[] (ArrayIndex index)
Value & | operator[] (int index)
const Value & | operator[] (ArrayIndex index) const
const Value & | operator[] (int index) const

## Static Public Member Functions
static Value const & | nullSingleton ()

## Public Attributes
CommentPlacement | placement

## Static Public Attributes
static const Value & | null = Value::nullSingleton()
static const Value & | nullRef = Value::nullSingleton()
static constexpr LargestInt | minLargestInt
| Minimum signed integer value that can be stored in a Json::Value.
static constexpr LargestInt | maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| Maximum signed integer value that can be stored in a Json::Value.
static constexpr LargestUInt | maxLargestUInt = LargestUInt(-1)
| Maximum unsigned integer value that can be stored in a Json::Value.
static constexpr Int | minInt = Int(~(UInt(-1) / 2))
| Minimum signed int value that can be stored in a Json::Value.
static constexpr Int | maxInt = Int(UInt(-1) / 2)
| Maximum signed int value that can be stored in a Json::Value.
static constexpr UInt | maxUInt = UInt(-1)
| Maximum unsigned int value that can be stored in a Json::Value.
static constexpr Int64 | minInt64 = Int64(~(UInt64(-1) / 2))
| Minimum signed 64 bits int value that can be stored in a Json::Value.
static constexpr Int64 | maxInt64 = Int64(UInt64(-1) / 2)
| Maximum signed 64 bits int value that can be stored in a Json::Value.
static constexpr UInt64 | maxUInt64 = UInt64(-1)
| Maximum unsigned 64 bits int value that can be stored in a Json::Value.
static constexpr UInt | defaultRealPrecision = 17
| Default precision for real value for string representation.
static constexpr double | maxUInt64AsDouble = 18446744073709551615.0

## Friends
class | ValueIteratorBase
struct | ::ValueTest

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

Values of an objectValue or arrayValue can be accessed using operator[]() methods. Non-const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resized and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtain default value in the case the required element does not exist.

It is possible to iterate over the list of member keys of an object using the getMemberNames() method.

Note
  Value string-length fit in size_t, but keys must be < 2^30. (The reason is an implementation detail.) A CharReader will raise an exception if a bound is exceeded to avoid security holes in your app, but the Value API does not check bounds. That is the responsibility of the caller.

Definition at line 207 of file value.h.

## Member Typedef Documentation

## ◆ ArrayIndex

using Json::Value::ArrayIndex = Json::ArrayIndex

Definition at line 223 of file value.h.

## ◆ const_iterator

using Json::Value::const_iterator = ValueConstIterator

Definition at line 214 of file value.h.

## ◆ Int

using Json::Value::Int = Json::Int

Definition at line 216 of file value.h.

## ◆ Int64

using Json::Value::Int64 = Json::Int64

Definition at line 219 of file value.h.

## ◆ iterator

using Json::Value::iterator = ValueIterator

Definition at line 213 of file value.h.

## ◆ LargestInt

using Json::Value::LargestInt = Json::LargestInt

Definition at line 221 of file value.h.

## ◆ LargestUInt

using Json::Value::LargestUInt = Json::LargestUInt

Definition at line 222 of file value.h.

## ◆ Members

using Json::Value::Members = std::vector<String>

Definition at line 212 of file value.h.

## ◆ UInt

using Json::Value::UInt = Json::UInt

Definition at line 215 of file value.h.

## ◆ UInt64

using Json::Value::UInt64 = Json::UInt64

Definition at line 218 of file value.h.

## ◆ value_type

using Json::Value::value_type = std::string

Definition at line 226 of file value.h.

## Constructor & Destructor Documentation

## ◆ Value() [1/14]

Json::Value::Value | ( | ValueType | type = nullValue | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}
Json::Value
Represents a JSON value.
Definition value.h:207
Json::arrayValue
@ arrayValue
array value (ordered list)
Definition value.h:128
Json::objectValue
@ objectValue
object value (collection of name/value pairs).
Definition value.h:129

Default constructor initialization must be equivalent to: memset( this, 0, sizeof(Value) ) This optimization is used in ValueInternalMap fast allocator.

Definition at line 392 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), Json::uintValue, and Value().

Referenced by append(), append(), back(), back(), compare(), copy(), copyPayload(), demand(), find(), find(), findArray(), findBool(), findDouble(), findInt(), findInt64(), findIntegral(), findNull(), findNumeric(), findObject(), findString(), findUInt(), findUInt64(), findValue(), front(), front(), get(), get(), get(), get(), insert(), insert(), is(), isMember(), Json::ValueIteratorBase::key(), nullSingleton(), operator!=(), operator<(), operator<=(), operator=(), operator=(), operator==(), operator>(), operator>=(), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), removeIndex(), removeMember(), removeMember(), removeMember(), resize(), swap(), swapPayload(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), Value(), and Value().

## ◆ Value() [2/14]

Json::Value::Value | ( | Int | value | ) |

Definition at line 421 of file json_value.cpp.

References Json::intValue, and Value().

## ◆ Value() [3/14]

Json::Value::Value | ( | UInt | value | ) |

Definition at line 426 of file json_value.cpp.

References Json::uintValue, and Value().

## ◆ Value() [4/14]

Json::Value::Value | ( | Int64 | value | ) |

Definition at line 431 of file json_value.cpp.

References Json::intValue, and Value().

## ◆ Value() [5/14]

Json::Value::Value | ( | UInt64 | value | ) |

Definition at line 435 of file json_value.cpp.

References Json::uintValue, and Value().

## ◆ Value() [6/14]

Json::Value::Value | ( | double | value | ) |

Definition at line 441 of file json_value.cpp.

References Json::realValue, and Value().

## ◆ Value() [7/14]

Json::Value::Value | ( | const char * | value | ) |

Copy til first 0. (NULL causes to seg-fault.).

Definition at line 446 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), JSON_ASSERT_MESSAGE, Json::stringValue, and Value().

## ◆ Value() [8/14]

Json::Value::Value | ( | const char * | begin,
|  | const char * | end )

Copy all, incl zeroes.

Definition at line 454 of file json_value.cpp.

References begin(), Json::duplicateAndPrefixStringValue(), end(), Json::stringValue, and Value().

## ◆ Value() [9/14]

Json::Value::Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor.

Note
  This works only for null-terminated strings. (We cannot change the size of this class, so we have nowhere to store the length, which might be computed later for various operations.)

Example of usage:

static StaticString foo("some text");
Json::Value aValue(foo);
Json::StaticString
Lightweight wrapper to tag static string.
Definition value.h:161

Definition at line 466 of file json_value.cpp.

References Json::StaticString::c_str(), Json::stringValue, and Value().

## ◆ Value() [10/14]

Json::Value::Value | ( | const String & | value | ) |

Definition at line 460 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), Json::stringValue, and Value().

## ◆ Value() [11/14]

Json::Value::Value | ( | bool | value | ) |

Definition at line 471 of file json_value.cpp.

References Json::booleanValue, and Value().

## ◆ Value() [12/14]

Json::Value::Value | ( | std::nullptr_t | ptr | ) |
| delete

References asCString(), asString(), begin(), compare(), copy(), copyPayload(), end(), getString(), operator!=(), operator<(), operator<=(), operator=(), operator==(), operator>(), operator>=(), swap(), swapPayload(), type(), and Value().

## ◆ Value() [13/14]

Json::Value::Value | ( | const Value & | other | ) |

Definition at line 476 of file json_value.cpp.

References Value().

## ◆ Value() [14/14]

Json::Value::Value | ( | Value && | other | ) |
| noexcept

Definition at line 481 of file json_value.cpp.

References Json::nullValue, swap(), and Value().

## ◆ ~Value()

Json::Value::~Value | ( |  | ) |

Definition at line 486 of file json_value.cpp.

References ~Value().

Referenced by ~Value().

Here is the caller graph for this function:

## Member Function Documentation

## ◆ __declspec()

Json::Value::__declspec | ( | deprecated("Use setComment(String const&) instead.") |  | ) | const

Deprecated
  Always pass len.

References JSONCPP_DEPRECATED.

## ◆ append() [1/2]

Value & Json::Value::append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

Definition at line 1221 of file json_value.cpp.

References append(), and Value().

Referenced by append(), append(), and is().

Here is the caller graph for this function:

## ◆ append() [2/2]

Value & Json::Value::append | ( | Value && | value | ) |

Definition at line 1223 of file json_value.cpp.

References append(), Json::arrayValue, JSON_ASSERT_MESSAGE, Json::nullValue, size(), type(), Value(), and Json::valueTypeToString().

## ◆ as() [1/10]

template<>

const char * Json::Value::as | ( |  | ) | const
| inline

Definition at line 806 of file value.h.

References as(), and asCString().

## ◆ as() [2/10]

template<>

float Json::Value::as | ( |  | ) | const
| inline

These as specializations are type conversions, and do not have a corresponding is.

Definition at line 805 of file value.h.

References as(), and asFloat().

## ◆ as() [3/10]

template<>

String Json::Value::as | ( |  | ) | const
| inline

Definition at line 800 of file value.h.

References as(), and asString().

## ◆ as() [4/10]

template<>

double Json::Value::as | ( |  | ) | const
| inline

Definition at line 797 of file value.h.

References as(), and asDouble().

## ◆ as() [5/10]

template<>

UInt64 Json::Value::as | ( |  | ) | const
| inline

Definition at line 793 of file value.h.

References as(), and asUInt64().

## ◆ as() [6/10]

template<>

Int64 Json::Value::as | ( |  | ) | const
| inline

Definition at line 790 of file value.h.

References as(), and asInt64().

## ◆ as() [7/10]

template<>

UInt Json::Value::as | ( |  | ) | const
| inline

Definition at line 786 of file value.h.

References as(), and asUInt().

## ◆ as() [8/10]

template<>

Int Json::Value::as | ( |  | ) | const
| inline

Definition at line 783 of file value.h.

References as(), and asInt().

## ◆ as() [9/10]

template<>

bool Json::Value::as | ( |  | ) | const
| inline

Definition at line 780 of file value.h.

References as(), and asBool().

## ◆ as() [10/10]

template<typename T>

T Json::Value::as | ( |  | ) | const
| delete

The as<T> and is<T> member function templates and specializations.

References JSONCPP_TEMPLATE_DELETE.

Referenced by as().

Here is the caller graph for this function:

## ◆ asBool()

bool Json::Value::asBool | ( |  | ) | const

Definition at line 854 of file json_value.cpp.

References asBool(), Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), and asBool().

Here is the caller graph for this function:

## ◆ asCString()

const char * Json::Value::asCString | ( |  | ) | const

Embedded zeroes could cause you trouble!

Definition at line 635 of file json_value.cpp.

References asCString(), Json::decodePrefixedString(), JSON_ASSERT_MESSAGE, Json::stringValue, and type().

Referenced by as(), asCString(), and Value().

Here is the caller graph for this function:

## ◆ asDouble()

double Json::Value::asDouble | ( |  | ) | const

Definition at line 809 of file json_value.cpp.

References asDouble(), Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), asDouble(), and isConvertibleTo().

Here is the caller graph for this function:

## ◆ asFloat()

float Json::Value::asFloat | ( |  | ) | const

Definition at line 831 of file json_value.cpp.

References asFloat(), Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), and asFloat().

Here is the caller graph for this function:

## ◆ asInt()

Value::Int Json::Value::asInt | ( |  | ) | const

Definition at line 699 of file json_value.cpp.

References asInt(), Json::booleanValue, Json::InRange(), Json::intValue, isInt(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxInt, minInt, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), asInt(), and asLargestInt().

Here is the caller graph for this function:

## ◆ asInt64()

Value::Int64 Json::Value::asInt64 | ( |  | ) | const

Definition at line 745 of file json_value.cpp.

References asInt64(), Json::booleanValue, Json::InRange(), Json::intValue, isInt64(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxInt64, minInt64, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), asInt64(), and asLargestInt().

Here is the caller graph for this function:

## ◆ asLargestInt()

LargestInt Json::Value::asLargestInt | ( |  | ) | const

Definition at line 793 of file json_value.cpp.

References asInt(), asInt64(), and asLargestInt().

Referenced by asLargestInt().

Here is the caller graph for this function:

## ◆ asLargestUInt()

LargestUInt Json::Value::asLargestUInt | ( |  | ) | const

Definition at line 801 of file json_value.cpp.

References asLargestUInt(), asUInt(), and asUInt64().

Referenced by asLargestUInt().

Here is the caller graph for this function:

## ◆ asString()

String Json::Value::asString | ( |  | ) | const

Embedded zeroes are possible.

Definition at line 673 of file json_value.cpp.

References asString(), Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, Json::stringValue, type(), Json::uintValue, and Json::valueToString().

Referenced by as(), asString(), isConvertibleTo(), and Value().

Here is the caller graph for this function:

## ◆ asUInt()

Value::UInt Json::Value::asUInt | ( |  | ) | const

Definition at line 721 of file json_value.cpp.

References asUInt(), Json::booleanValue, Json::InRange(), Json::intValue, isUInt(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxUInt, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), asLargestUInt(), and asUInt().

Here is the caller graph for this function:

## ◆ asUInt64()

Value::UInt64 Json::Value::asUInt64 | ( |  | ) | const

Definition at line 771 of file json_value.cpp.

References asUInt64(), Json::booleanValue, Json::InRange(), Json::intValue, isUInt64(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxUInt64, Json::nullValue, Json::realValue, type(), and Json::uintValue.

Referenced by as(), asLargestUInt(), and asUInt64().

Here is the caller graph for this function:

## ◆ back() [1/2]

Value & Json::Value::back | ( |  | ) |
| inline

Returns a reference to the last element in the Value.

Requires that this value holds an array or json object, with at least one element.

Definition at line 1181 of file value.h.

References back(), end(), and Value().

## ◆ back() [2/2]

const Value & Json::Value::back | ( |  | ) | const
| inline

Returns a reference to the last element in the Value.

Requires that value holds an array or json object, with at least one element.

Definition at line 1179 of file value.h.

References back(), end(), and Value().

Referenced by back(), and back().

Here is the caller graph for this function:

## ◆ begin() [1/2]

Value::iterator Json::Value::begin | ( |  | ) |

Definition at line 1578 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ begin() [2/2]

Value::const_iterator Json::Value::begin | ( |  | ) | const

Definition at line 1552 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

Referenced by demand(), find(), front(), front(), get(), getString(), isMember(), members(), members(), removeMember(), Value(), and Value().

Here is the caller graph for this function:

## ◆ clear()

void Json::Value::clear | ( |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

Definition at line 940 of file json_value.cpp.

References Json::arrayValue, clear(), JSON_ASSERT_MESSAGE, Json::nullValue, Json::objectValue, and type().

Referenced by clear(), is(), and resize().

Here is the caller graph for this function:

## ◆ compare()

int Json::Value::compare | ( | const Value & | other | ) | const

Definition at line 527 of file json_value.cpp.

References compare(), and Value().

Referenced by compare(), and Value().

Here is the caller graph for this function:

## ◆ copy()

void Json::Value::copy | ( | const Value & | other | ) |

copy everything.

Definition at line 518 of file json_value.cpp.

References copy(), copyPayload(), and Value().

Referenced by copy(), and Value().

Here is the caller graph for this function:

## ◆ copyPayload()

void Json::Value::copyPayload | ( | const Value & | other | ) |

copy values but leave comments and source offsets in place.

Definition at line 506 of file json_value.cpp.

References copyPayload(), and Value().

Referenced by copy(), copyPayload(), and Value().

Here is the caller graph for this function:

## ◆ demand()

Value * Json::Value::demand | ( | char const * | begin,
|  | char const * | end )

Most general and efficient version of object-mutators.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Returns
  non-zero, but JSON_ASSERT if this is neither object nor nullValue.

Definition at line 1190 of file json_value.cpp.

References begin(), demand(), end(), JSON_ASSERT_MESSAGE, Json::nullValue, Json::objectValue, type(), and Value().

Referenced by demand().

Here is the caller graph for this function:

## ◆ empty()

bool Json::Value::empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

Definition at line 932 of file json_value.cpp.

References empty(), isArray(), isNull(), isObject(), and size().

Referenced by empty(), is(), isConvertibleTo(), Json::CharReaderBuilder::validate(), and Json::StreamWriterBuilder::validate().

Here is the caller graph for this function:

## ◆ end() [1/2]

Value::iterator Json::Value::end | ( |  | ) |

Definition at line 1591 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ end() [2/2]

Value::const_iterator Json::Value::end | ( |  | ) | const

Definition at line 1565 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

Referenced by back(), back(), demand(), find(), get(), getString(), isMember(), members(), members(), removeMember(), Value(), and Value().

Here is the caller graph for this function:

## ◆ find() [1/2]

Value const * Json::Value::find | ( | char const * | begin,
|  | char const * | end ) const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Definition at line 1136 of file json_value.cpp.

References begin(), end(), find(), JSON_ASSERT_MESSAGE, Json::nullValue, Json::objectValue, type(), and Value().

Referenced by find(), find(), findValue(), get(), isMember(), operator[](), and operator[]().

Here is the caller graph for this function:

## ◆ find() [2/2]

Value const * Json::Value::find | ( | const String & | key | ) | const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Definition at line 1149 of file json_value.cpp.

References find(), and Value().

## ◆ findArray()

Value const * Json::Value::findArray | ( | const String & | key | ) | const

Definition at line 1183 of file json_value.cpp.

References findArray(), findValue(), and Value().

Referenced by findArray().

Here is the caller graph for this function:

## ◆ findBool()

Value const * Json::Value::findBool | ( | const String & | key | ) | const

Definition at line 1156 of file json_value.cpp.

References findBool(), findValue(), and Value().

Referenced by findBool().

Here is the caller graph for this function:

## ◆ findDouble()

Value const * Json::Value::findDouble | ( | const String & | key | ) | const

Definition at line 1174 of file json_value.cpp.

References findDouble(), findValue(), and Value().

Referenced by findDouble().

Here is the caller graph for this function:

## ◆ findInt()

Value const * Json::Value::findInt | ( | const String & | key | ) | const

Definition at line 1159 of file json_value.cpp.

References findInt(), findValue(), and Value().

Referenced by findInt().

Here is the caller graph for this function:

## ◆ findInt64()

Value const * Json::Value::findInt64 | ( | const String & | key | ) | const

Definition at line 1162 of file json_value.cpp.

References findInt64(), findValue(), and Value().

Referenced by findInt64().

Here is the caller graph for this function:

## ◆ findIntegral()

Value const * Json::Value::findIntegral | ( | const String & | key | ) | const

Definition at line 1171 of file json_value.cpp.

References findIntegral(), findValue(), and Value().

Referenced by findIntegral().

Here is the caller graph for this function:

## ◆ findNull()

Value const * Json::Value::findNull | ( | const String & | key | ) | const

Definition at line 1153 of file json_value.cpp.

References findNull(), findValue(), and Value().

Referenced by findNull().

Here is the caller graph for this function:

## ◆ findNumeric()

Value const * Json::Value::findNumeric | ( | const String & | key | ) | const

Definition at line 1177 of file json_value.cpp.

References findNumeric(), findValue(), and Value().

Referenced by findNumeric().

Here is the caller graph for this function:

## ◆ findObject()

Value const * Json::Value::findObject | ( | const String & | key | ) | const

Definition at line 1186 of file json_value.cpp.

References findObject(), findValue(), and Value().

Referenced by findObject().

Here is the caller graph for this function:

## ◆ findString()

Value const * Json::Value::findString | ( | const String & | key | ) | const

Definition at line 1180 of file json_value.cpp.

References findString(), findValue(), and Value().

Referenced by findString().

Here is the caller graph for this function:

## ◆ findUInt()

Value const * Json::Value::findUInt | ( | const String & | key | ) | const

Definition at line 1165 of file json_value.cpp.

References findUInt(), findValue(), and Value().

Referenced by findUInt().

Here is the caller graph for this function:

## ◆ findUInt64()

Value const * Json::Value::findUInt64 | ( | const String & | key | ) | const

Definition at line 1168 of file json_value.cpp.

References findUInt64(), findValue(), and Value().

Referenced by findUInt64().

Here is the caller graph for this function:

## ◆ findValue()

template<typename T, bool(T::*)() const TMemFn>

Value const * Json::Value::findValue | ( | const String & | key | ) | const
| inline

Calls find and only returns a valid pointer if the type is found.

Definition at line 576 of file value.h.

References find(), and Value().

Referenced by findArray(), findBool(), findDouble(), findInt(), findInt64(), findIntegral(), findNull(), findNumeric(), findObject(), findString(), findUInt(), and findUInt64().

Here is the caller graph for this function:

## ◆ front() [1/2]

Value & Json::Value::front | ( |  | ) |
| inline

Returns a reference to the first element in the Value.

Requires that this value holds an array or json object, with at least one element.

Definition at line 1177 of file value.h.

References begin(), front(), and Value().

## ◆ front() [2/2]

const Value & Json::Value::front | ( |  | ) | const
| inline

Returns a reference to the first element in the Value.

Requires that this value holds an array or json object, with at least one element.

Definition at line 1175 of file value.h.

References begin(), front(), and Value().

Referenced by front(), and front().

Here is the caller graph for this function:

## ◆ get() [1/4]

Value Json::Value::get | ( | ArrayIndex | index,
|  | const Value & | defaultValue ) const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

Definition at line 1129 of file json_value.cpp.

References get(), nullSingleton(), and Value().

Referenced by get(), get(), get(), get(), and is().

Here is the caller graph for this function:

## ◆ get() [2/4]

Value Json::Value::get | ( | const char * | begin,
|  | const char * | end,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy
  key may contain embedded nulls.

Definition at line 1251 of file json_value.cpp.

References begin(), end(), find(), get(), and Value().

## ◆ get() [3/4]

Value Json::Value::get | ( | const char * | key,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Definition at line 1256 of file json_value.cpp.

References get(), and Value().

## ◆ get() [4/4]

Value Json::Value::get | ( | const String & | key,
|  | const Value & | defaultValue ) const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

Definition at line 1259 of file json_value.cpp.

References get(), and Value().

## ◆ getComment()

String Json::Value::getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

Definition at line 1530 of file json_value.cpp.

References placement.

## ◆ getMemberNames()

Value::Members Json::Value::getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

Definition at line 1332 of file json_value.cpp.

References getMemberNames(), JSON_ASSERT_MESSAGE, members(), Json::nullValue, Json::objectValue, and type().

Referenced by getMemberNames().

Here is the caller graph for this function:

## ◆ getOffsetLimit()

ptrdiff_t Json::Value::getOffsetLimit | ( |  | ) | const

Definition at line 1540 of file json_value.cpp.

Referenced by Json::Reader::pushError(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getOffsetStart()

ptrdiff_t Json::Value::getOffsetStart | ( |  | ) | const

Definition at line 1538 of file json_value.cpp.

Referenced by Json::Reader::pushError(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getString()

bool Json::Value::getString | ( | char const ** | begin,
|  | char const ** | end ) const

Get raw char* of string-value.

Returns
  false if !string. (Seg-fault if str or end are NULL.)

Definition at line 661 of file json_value.cpp.

References begin(), Json::decodePrefixedString(), end(), getString(), Json::stringValue, and type().

Referenced by getString(), and Value().

Here is the caller graph for this function:

## ◆ hasComment()

bool Json::Value::hasComment | ( | CommentPlacement | placement | ) | const

Definition at line 1526 of file json_value.cpp.

References placement.

Referenced by toStyledString().

Here is the caller graph for this function:

## ◆ insert() [1/2]

bool Json::Value::insert | ( | ArrayIndex | index,
|  | const Value & | newValue )

Insert value in array at specific index.

Definition at line 1233 of file json_value.cpp.

References insert(), and Value().

Referenced by insert(), insert(), and is().

Here is the caller graph for this function:

## ◆ insert() [2/2]

bool Json::Value::insert | ( | ArrayIndex | index,
|  | Value && | newValue )

Definition at line 1237 of file json_value.cpp.

References Json::arrayValue, insert(), JSON_ASSERT_MESSAGE, Json::nullValue, size(), type(), and Value().

## ◆ is() [1/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 801 of file value.h.

References is(), and isString().

## ◆ is() [2/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 798 of file value.h.

References is(), and isDouble().

## ◆ is() [3/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 794 of file value.h.

References is(), and isUInt64().

## ◆ is() [4/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 791 of file value.h.

References is(), and isInt64().

## ◆ is() [5/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 787 of file value.h.

References is(), and isUInt().

## ◆ is() [6/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 784 of file value.h.

References is(), and isInt().

## ◆ is() [7/8]

template<>

bool Json::Value::is | ( |  | ) | const
| inline

Definition at line 781 of file value.h.

References is(), and isBool().

## ◆ is() [8/8]

template<typename T>

bool Json::Value::is | ( |  | ) | const
| delete

References append(), clear(), empty(), get(), insert(), is(), isConvertibleTo(), isValidIndex(), JSONCPP_TEMPLATE_DELETE, operator[](), resize(), size(), and Value().

Referenced by is(), and is().

Here is the caller graph for this function:

## ◆ isArray()

bool Json::Value::isArray | ( |  | ) | const

Definition at line 1477 of file json_value.cpp.

References Json::arrayValue, isArray(), and type().

Referenced by empty(), isArray(), Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isBool()

bool Json::Value::isBool | ( |  | ) | const

Definition at line 1355 of file json_value.cpp.

References Json::booleanValue, isBool(), and type().

Referenced by is(), and isBool().

Here is the caller graph for this function:

## ◆ isConvertibleTo()

bool Json::Value::isConvertibleTo | ( | ValueType | other | ) | const

Definition at line 875 of file json_value.cpp.

References Json::arrayValue, asDouble(), asString(), Json::booleanValue, empty(), Json::InRange(), Json::intValue, isConvertibleTo(), isInt(), isNumeric(), isUInt(), JSON_ASSERT_UNREACHABLE, maxInt, maxUInt, minInt, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), and Json::uintValue.

Referenced by is(), and isConvertibleTo().

Here is the caller graph for this function:

## ◆ isDouble()

bool Json::Value::isDouble | ( |  | ) | const

Definition at line 1469 of file json_value.cpp.

References Json::intValue, isDouble(), Json::realValue, type(), and Json::uintValue.

Referenced by is(), isDouble(), and isNumeric().

Here is the caller graph for this function:

## ◆ isInt()

bool Json::Value::isInt | ( |  | ) | const

Definition at line 1357 of file json_value.cpp.

References Json::intValue, isInt(), Json::IsIntegral(), maxInt, minInt, Json::realValue, type(), and Json::uintValue.

Referenced by asInt(), is(), isConvertibleTo(), and isInt().

Here is the caller graph for this function:

## ◆ isInt64()

bool Json::Value::isInt64 | ( |  | ) | const

Definition at line 1399 of file json_value.cpp.

References Json::intValue, isInt64(), Json::IsIntegral(), maxInt64, minInt64, Json::realValue, type(), and Json::uintValue.

Referenced by asInt64(), is(), and isInt64().

Here is the caller graph for this function:

## ◆ isIntegral()

bool Json::Value::isIntegral | ( |  | ) | const

Definition at line 1443 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), isIntegral(), maxUInt, maxUInt64AsDouble, minInt, minInt64, Json::realValue, type(), and Json::uintValue.

Referenced by isIntegral().

Here is the caller graph for this function:

## ◆ isMember() [1/3]

bool Json::Value::isMember | ( | const char * | begin,
|  | const char * | end ) const

Same as isMember(String const& key)const.

Definition at line 1321 of file json_value.cpp.

References begin(), end(), find(), isMember(), and Value().

## ◆ isMember() [2/3]

bool Json::Value::isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

Note
  'key' must be null-terminated.

Definition at line 1325 of file json_value.cpp.

References isMember().

Referenced by isMember(), isMember(), and isMember().

Here is the caller graph for this function:

## ◆ isMember() [3/3]

bool Json::Value::isMember | ( | const String & | key | ) | const

Return true if the object has a member named key.

Parameters

  key | may contain embedded nulls.

Definition at line 1328 of file json_value.cpp.

References isMember().

## ◆ isNull()

bool Json::Value::isNull | ( |  | ) | const

Definition at line 1353 of file json_value.cpp.

References isNull(), Json::nullValue, and type().

Referenced by empty(), isNull(), and operator bool().

Here is the caller graph for this function:

## ◆ isNumeric()

bool Json::Value::isNumeric | ( |  | ) | const

Definition at line 1473 of file json_value.cpp.

References isDouble(), and isNumeric().

Referenced by isConvertibleTo(), and isNumeric().

Here is the caller graph for this function:

## ◆ isObject()

bool Json::Value::isObject | ( |  | ) | const

Definition at line 1479 of file json_value.cpp.

References isObject(), Json::objectValue, and type().

Referenced by empty(), isObject(), Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isString()

bool Json::Value::isString | ( |  | ) | const

Definition at line 1475 of file json_value.cpp.

References isString(), Json::stringValue, and type().

Referenced by is(), and isString().

Here is the caller graph for this function:

## ◆ isUInt()

bool Json::Value::isUInt | ( |  | ) | const

Definition at line 1376 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), isUInt(), maxUInt, Json::realValue, type(), and Json::uintValue.

Referenced by asUInt(), is(), isConvertibleTo(), and isUInt().

Here is the caller graph for this function:

## ◆ isUInt64()

bool Json::Value::isUInt64 | ( |  | ) | const

Definition at line 1423 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), isUInt64(), maxUInt64AsDouble, Json::realValue, type(), and Json::uintValue.

Referenced by asUInt64(), is(), and isUInt64().

Here is the caller graph for this function:

## ◆ isValidIndex()

bool Json::Value::isValidIndex | ( | ArrayIndex | index | ) | const

Return true if index < size().

Definition at line 1134 of file json_value.cpp.

References isValidIndex(), and size().

Referenced by is(), isValidIndex(), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ members() [1/2]

ValueMembersView Json::Value::members | ( |  | ) |
| inline

Definition at line 1166 of file value.h.

References begin(), end(), and members().

Referenced by getMemberNames(), members(), and members().

Here is the caller graph for this function:

## ◆ members() [2/2]

ValueConstMembersView Json::Value::members | ( |  | ) | const
| inline

Definition at line 1169 of file value.h.

References begin(), end(), and members().

## ◆ nullSingleton()

Value const & Json::Value::nullSingleton | ( |  | ) |
| static

Definition at line 70 of file json_value.cpp.

References Value().

Referenced by get(), operator[](), operator[](), operator[](), operator[](), Json::Path::resolve(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ operator bool()

Json::Value::operator bool | ( |  | ) | const
| explicit

Return !isNull().

Definition at line 938 of file json_value.cpp.

References isNull().

## ◆ operator!=()

bool Json::Value::operator!= | ( | const Value & | other | ) | const

Definition at line 633 of file json_value.cpp.

References operator!=(), and Value().

Referenced by operator!=(), and Value().

Here is the caller graph for this function:

## ◆ operator<()

bool Json::Value::operator< | ( | const Value & | other | ) | const

Compare payload only, not comments etc.

Definition at line 535 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, operator<(), Json::realValue, Json::stringValue, type(), Json::uintValue, and Value().

Referenced by operator<(), and Value().

Here is the caller graph for this function:

## ◆ operator<=()

bool Json::Value::operator<= | ( | const Value & | other | ) | const

Definition at line 585 of file json_value.cpp.

References operator<=(), and Value().

Referenced by operator<=(), and Value().

Here is the caller graph for this function:

## ◆ operator=() [1/2]

Value & Json::Value::operator= | ( | const Value & | other | ) |

Note
  Overwrite existing comments. To preserve comments, use swapPayload().

Definition at line 491 of file json_value.cpp.

References operator=(), and Value().

Referenced by operator=(), operator=(), and Value().

Here is the caller graph for this function:

## ◆ operator=() [2/2]

Value & Json::Value::operator= | ( | Value && | other | ) |
| noexcept

Definition at line 496 of file json_value.cpp.

References operator=(), and Value().

## ◆ operator==()

bool Json::Value::operator== | ( | const Value & | other | ) | const

Definition at line 591 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, operator==(), Json::realValue, Json::stringValue, type(), Json::uintValue, and Value().

Referenced by operator==(), and Value().

Here is the caller graph for this function:

## ◆ operator>()

bool Json::Value::operator> | ( | const Value & | other | ) | const

Definition at line 589 of file json_value.cpp.

References operator>(), and Value().

Referenced by operator>(), and Value().

Here is the caller graph for this function:

## ◆ operator>=()

bool Json::Value::operator>= | ( | const Value & | other | ) | const

Definition at line 587 of file json_value.cpp.

References operator>=(), and Value().

Referenced by operator>=(), and Value().

Here is the caller graph for this function:

## ◆ operator[]() [1/9]

Value & Json::Value::operator[] | ( | ArrayIndex | index | ) |

Access an array element (zero based index). If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 977 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, nullSingleton(), Json::nullValue, operator[](), type(), and Value().

Referenced by is(), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), operator[](), and operator[]().

Here is the caller graph for this function:

## ◆ operator[]() [2/9]

const Value & Json::Value::operator[] | ( | ArrayIndex | index | ) | const

Access an array element (zero based index). (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1000 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, nullSingleton(), Json::nullValue, operator[](), type(), and Value().

## ◆ operator[]() [3/9]

Value & Json::Value::operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

Note
  Because of our implementation, keys are limited to 2^30 -1 chars. Exceeding that will cause an exception.

Definition at line 1209 of file json_value.cpp.

References operator[](), and Value().

## ◆ operator[]() [4/9]

const Value & Json::Value::operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Definition at line 1196 of file json_value.cpp.

References find(), nullSingleton(), operator[](), and Value().

## ◆ operator[]() [5/9]

Value & Json::Value::operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object has no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

Definition at line 1217 of file json_value.cpp.

References Json::StaticString::c_str(), operator[](), and Value().

## ◆ operator[]() [6/9]

Value & Json::Value::operator[] | ( | const String & | key | ) |

Access an object value by name, create a null member if it does not exist.

Parameters

  key | may contain embedded nulls.

Definition at line 1213 of file json_value.cpp.

References operator[](), and Value().

## ◆ operator[]() [7/9]

Value const & Json::Value::operator[] | ( | const String & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Parameters

  key | may contain embedded nulls.

Definition at line 1202 of file json_value.cpp.

References find(), nullSingleton(), operator[](), and Value().

## ◆ operator[]() [8/9]

Value & Json::Value::operator[] | ( | int | index | ) |

Definition at line 993 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, operator[](), and Value().

## ◆ operator[]() [9/9]

const Value & Json::Value::operator[] | ( | int | index | ) | const

Definition at line 1013 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, operator[](), and Value().

## ◆ removeIndex()

bool Json::Value::removeIndex | ( | ArrayIndex | index,
|  | Value * | removed )

Remove the indexed array element.

O(n) expensive operations. Update 'removed' iff removed.

Returns
  true if removed (no exceptions)

Definition at line 1297 of file json_value.cpp.

References Json::arrayValue, removeIndex(), size(), type(), and Value().

Referenced by removeIndex().

Here is the caller graph for this function:

## ◆ removeMember() [1/5]

bool Json::Value::removeMember | ( | const char * | begin,
|  | const char * | end,
|  | Value * | removed )

Same as removeMember(String const& key, Value* removed).

Definition at line 1263 of file json_value.cpp.

References begin(), end(), Json::objectValue, removeMember(), type(), and Value().

## ◆ removeMember() [2/5]

void Json::Value::removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Definition at line 1284 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, Json::objectValue, removeMember(), type(), and Json::valueTypeToString().

Referenced by removeMember(), removeMember(), removeMember(), removeMember(), and removeMember().

Here is the caller graph for this function:

## ◆ removeMember() [3/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | Value * | removed )

Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.

Definition at line 1277 of file json_value.cpp.

References removeMember(), and Value().

## ◆ removeMember() [4/5]

void Json::Value::removeMember | ( | const String & | key | ) |

Same as removeMember(const char*).

Parameters

  key | may contain embedded nulls.

Definition at line 1295 of file json_value.cpp.

References removeMember().

## ◆ removeMember() [5/5]

bool Json::Value::removeMember | ( | String const & | key,
|  | Value * | removed )

Remove the named map member.

Update 'removed' iff removed.

Parameters

  key | may contain embedded nulls.

Returns
  true iff removed (no exceptions)

Definition at line 1280 of file json_value.cpp.

References removeMember(), and Value().

## ◆ resize()

void Json::Value::resize | ( | ArrayIndex | newSize | ) |

Resize the array to newSize elements.

New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

Definition at line 956 of file json_value.cpp.

References Json::arrayValue, clear(), JSON_ASSERT, JSON_ASSERT_MESSAGE, Json::nullValue, resize(), size(), type(), Value(), and Json::valueTypeToString().

Referenced by is(), and resize().

Here is the caller graph for this function:

## ◆ setComment() [1/2]

void Json::Value::setComment | ( | const char * | comment,
|  | size_t | len,
|  | CommentPlacement | placement )
| inline

Comments must be //... or /* ... *‍/.

Definition at line 668 of file value.h.

References placement, and setComment().

Referenced by Json::Reader::parse(), and setComment().

Here is the caller graph for this function:

## ◆ setComment() [2/2]

void Json::Value::setComment | ( | String | comment,
|  | CommentPlacement | placement )

Comments must be //... or /* ... *‍/.

Definition at line 1515 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, and placement.

## ◆ setOffsetLimit()

void Json::Value::setOffsetLimit | ( | ptrdiff_t | limit | ) |

Definition at line 1536 of file json_value.cpp.

## ◆ setOffsetStart()

void Json::Value::setOffsetStart | ( | ptrdiff_t | start | ) |

Definition at line 1534 of file json_value.cpp.

## ◆ size()

ArrayIndex Json::Value::size | ( |  | ) | const

Number of values in array or object.

Definition at line 909 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, size(), Json::stringValue, type(), and Json::uintValue.

Referenced by append(), empty(), insert(), is(), isValidIndex(), removeIndex(), resize(), and size().

Here is the caller graph for this function:

## ◆ swap()

void Json::Value::swap | ( | Value & | other | ) |

Swap everything.

Definition at line 511 of file json_value.cpp.

References swap(), swapPayload(), and Value().

Referenced by Json::swap(), swap(), Value(), and Value().

Here is the caller graph for this function:

## ◆ swapPayload()

void Json::Value::swapPayload | ( | Value & | other | ) |

Swap values but leave comments and source offsets in place.

Definition at line 501 of file json_value.cpp.

References swapPayload(), and Value().

Referenced by swap(), swapPayload(), and Value().

Here is the caller graph for this function:

## ◆ toStyledString()

String Json::Value::toStyledString | ( |  | ) | const

Definition at line 1542 of file json_value.cpp.

References Json::commentBefore, hasComment(), and Json::writeString().

## ◆ type()

ValueType Json::Value::type | ( |  | ) | const

Definition at line 523 of file json_value.cpp.

References type().

Referenced by append(), asBool(), asCString(), asDouble(), asFloat(), asInt(), asInt64(), asString(), asUInt(), asUInt64(), begin(), begin(), clear(), demand(), end(), end(), find(), getMemberNames(), getString(), insert(), isArray(), isBool(), isConvertibleTo(), isDouble(), isInt(), isInt64(), isIntegral(), isNull(), isObject(), isString(), isUInt(), isUInt64(), operator<(), operator==(), operator[](), operator[](), removeIndex(), removeMember(), removeMember(), resize(), size(), type(), Value(), and Value().

Here is the caller graph for this function:

## Friends And Related Symbol Documentation

## ◆ ::ValueTest

friend struct ::ValueTest
| friend

Definition at line 209 of file value.h.

## ◆ ValueIteratorBase

friend class ValueIteratorBase
| friend

Definition at line 208 of file value.h.

References ValueIteratorBase.

Referenced by ValueIteratorBase.

## Member Data Documentation

## ◆ defaultRealPrecision

UInt Json::Value::defaultRealPrecision = 17
| staticconstexpr

Default precision for real value for string representation.

Definition at line 261 of file value.h.

## ◆ maxInt

Int Json::Value::maxInt = Int(UInt(-1) / 2)
| staticconstexpr

Maximum signed int value that can be stored in a Json::Value.

Definition at line 248 of file value.h.

Referenced by asInt(), Json::duplicateAndPrefixStringValue(), Json::duplicateStringValue(), isConvertibleTo(), and isInt().

## ◆ maxInt64

Int64 Json::Value::maxInt64 = Int64(UInt64(-1) / 2)
| staticconstexpr

Maximum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 256 of file value.h.

Referenced by asInt64(), and isInt64().

## ◆ maxLargestInt

LargestInt Json::Value::maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| staticconstexpr

Maximum signed integer value that can be stored in a Json::Value.

Definition at line 241 of file value.h.

Referenced by Json::valueToString().

## ◆ maxLargestUInt

LargestUInt Json::Value::maxLargestUInt = LargestUInt(-1)
| staticconstexpr

Maximum unsigned integer value that can be stored in a Json::Value.

Definition at line 243 of file value.h.

## ◆ maxUInt

UInt Json::Value::maxUInt = UInt(-1)
| staticconstexpr

Maximum unsigned int value that can be stored in a Json::Value.

Definition at line 250 of file value.h.

Referenced by asUInt(), isConvertibleTo(), isIntegral(), and isUInt().

## ◆ maxUInt64

UInt64 Json::Value::maxUInt64 = UInt64(-1)
| staticconstexpr

Maximum unsigned 64 bits int value that can be stored in a Json::Value.

Definition at line 258 of file value.h.

Referenced by asUInt64().

## ◆ maxUInt64AsDouble

double Json::Value::maxUInt64AsDouble = 18446744073709551615.0
| staticconstexpr

Definition at line 265 of file value.h.

Referenced by isIntegral(), and isUInt64().

## ◆ minInt

Int Json::Value::minInt = Int(~(UInt(-1) / 2))
| staticconstexpr

Minimum signed int value that can be stored in a Json::Value.

Definition at line 246 of file value.h.

Referenced by asInt(), isConvertibleTo(), isInt(), and isIntegral().

## ◆ minInt64

Int64 Json::Value::minInt64 = Int64(~(UInt64(-1) / 2))
| staticconstexpr

Minimum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 254 of file value.h.

Referenced by asInt64(), isInt64(), and isIntegral().

## ◆ minLargestInt

LargestInt Json::Value::minLargestInt
| staticconstexpr

Initial value:
=
LargestInt(~(LargestUInt(-1) / 2))
Json::Value::LargestInt
Json::LargestInt LargestInt
Definition value.h:221
Json::Value::LargestUInt
Json::LargestUInt LargestUInt
Definition value.h:222

Minimum signed integer value that can be stored in a Json::Value.

Definition at line 238 of file value.h.

Referenced by Json::valueToString().

## ◆ null

Value const & Json::Value::null = Value::nullSingleton()
| static

Definition at line 230 of file value.h.

## ◆ nullRef

Value const & Json::Value::nullRef = Value::nullSingleton()
| static

Definition at line 231 of file value.h.

## ◆ placement

CommentPlacement Json::Value::placement

Initial value:
{
setComment(String(comment, strlen(comment)), placement)
Json::Value::setComment
void setComment(const char *comment, size_t len, CommentPlacement placement)
Comments must be //... or /* ... *‍/.
Definition value.h:668
Json::Value::placement
CommentPlacement placement
Definition value.h:664
Json::String
std::basic_string< char, std::char_traits< char >, Allocator< char > > String
Definition config.h:135

Definition at line 664 of file value.h.

Referenced by getComment(), hasComment(), setComment(), and setComment().

The documentation for this class was generated from the following files:

- include/json/value.h
- src/lib_json/json_value.cpp